<?php

namespace Modules\Qualificacao\Services;

use Doctrine\DBAL\ParameterType;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class Gql00900TesteDoProdutoService 
{

    protected $connection;
    protected $novoCodigo;

    public function __construct($entityManager, $environment, $novoCodigo)
    {
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
        $this->novoCodigo = $novoCodigo;
    }
    
    public function salvaTeste($row) {
        $row["IDMARCAPRTES"] = $row["APROVADO"];
		$param = array(
		    'NRTESTEPROD'  => $row['NRTESTEPROD'],
		    'CDFORNECED'  => $row['CDFORNECED'],
		    'CDPRODUTO'  => $row['CDPRODUTO'],
		    'CDMARCA'  => $row['CDMARCA'],
		    'DTTESTE'  => $row['DTTESTE'],
		    'NMRESPTESTE'  => $row['NMRESPTESTE'],
		    'DTVALAPRTEST'  => $row['DTVALAPRTEST'],
		    'IDMARCAPRTES'  => $row['IDMARCAPRTES'],
		    'IDTIPREN'  => $row['IDTIPREN'],
		    'VRRENDATUTES'  => $row['VRRENDATUTES'],
		    'DSRENDATUAL'  => $row['DSRENDATUAL'],
		    'NMFABROPCTES'  => $row['NMFABROPCTES'],
		    'NMTIPOEMBAL'  => $row['NMTIPOEMBAL'],
		    'IDEMBDATVAL'  => $row['IDEMBDATVAL'],
		    'DSREGISTTEST'  => $row['DSREGISTTEST'],
		    'IDASPVISUAL'  => $row['IDASPVISUAL'],
		    'IDASPCOR'  => $row['IDASPCOR'],
		    'IDASPODOR'  => $row['IDASPODOR'],
		    'IDASPSABOR'  => $row['IDASPSABOR'],
		    'IDASPTEXT'  => $row['IDASPTEXT'],
		    'IDTESTBROM'  => $row['IDTESTBROM'],
		    'IDPRATEMB'  => $row['IDPRATEMB'],
		    'IDPRATMANIP'  => $row['IDPRATMANIP'],
		    'HRTEMPOELAB'  => $row['HRTEMPOELAB'],
		    'IDLEGIVIGE' => $row['IDLEGIVIGE']
		);
        $query = "INSERT INTO TESTEPROD
          (NRTESTEPROD, CDFORNECED, CDPRODUTO, CDMARCA, DTTESTE, NMRESPTESTE, DTVALAPRTEST,
           IDMARCAPRTES, IDTIPREN, VRRENDATUTES, DSRENDATUAL, NMFABROPCTES, NMTIPOEMBAL,
           IDEMBDATVAL, DSREGISTTEST, IDASPVISUAL, IDASPCOR, IDASPODOR, IDASPSABOR,
           IDASPTEXT, IDTESTBROM, IDPRATEMB, IDPRATMANIP, HRTEMPOELAB, IDLEGIVIGE)
        values
          (:NRTESTEPROD, :CDFORNECED, :CDPRODUTO, :CDMARCA, :DTTESTE, :NMRESPTESTE,
           :DTVALAPRTEST, :IDMARCAPRTES, :IDTIPREN, :VRRENDATUTES, :DSRENDATUAL,
           :NMFABROPCTES, :NMTIPOEMBAL, :IDEMBDATVAL, :DSREGISTTEST, :IDASPVISUAL,
           :IDASPCOR, :IDASPODOR, :IDASPSABOR, :IDASPTEXT, :IDTESTBROM, :IDPRATEMB,
           :IDPRATMANIP, :HRTEMPOELAB, :IDLEGIVIGE)";
        try {
            $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $this->updateTesteprod($row);
            $this->procedureUpdate($row);
            $this->insertMarcprod($row);
            $this->procedureIncluir($row);
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function atualizaTeste($row) {
        $row["IDMARCAPRTES"] = $row["APROVADO"];
		$param = array(
		    'CDFORNECED'  => $row['CDFORNECED'],
		    'CDPRODUTO'  => $row['CDPRODUTO'],
		    'CDMARCA'  => $row['CDMARCA'],
		    'DTTESTE'  => $row['DTTESTE'],
		    'NMRESPTESTE'  => $row['NMRESPTESTE'],
		    'DTVALAPRTEST'  => $row['DTVALAPRTEST'],
		    'IDMARCAPRTES'  => $row['IDMARCAPRTES'],
		    'IDTIPREN'  => $row['IDTIPREN'],
		    'VRRENDATUTES'  => $row['VRRENDATUTES'],
		    'DSRENDATUAL'  => $row['DSRENDATUAL'],
		    'NMFABROPCTES'  => $row['NMFABROPCTES'],
		    'NMTIPOEMBAL'  => $row['NMTIPOEMBAL'],
		    'IDEMBDATVAL'  => $row['IDEMBDATVAL'],
		    'DSREGISTTEST'  => $row['DSREGISTTEST'],
		    'IDASPVISUAL'  => $row['IDASPVISUAL'],
		    'IDASPCOR'  => $row['IDASPCOR'],
		    'IDASPODOR'  => $row['IDASPODOR'],
		    'IDASPSABOR'  => $row['IDASPSABOR'],
		    'IDASPTEXT'  => $row['IDASPTEXT'],
		    'IDTESTBROM'  => $row['IDTESTBROM'],
		    'IDPRATEMB'  => $row['IDPRATEMB'],
		    'IDPRATMANIP'  => $row['IDPRATMANIP'],
		    'HRTEMPOELAB'  => $row['HRTEMPOELAB'],
		    'IDLEGIVIGE' => $row['IDLEGIVIGE'],
		    'NRTESTEPROD'  => $row['NRTESTEPROD'],
		);
        $query = "UPDATE TESTEPROD SET
              CDFORNECED = :CDFORNECED,
              CDPRODUTO = :CDPRODUTO,
              CDMARCA = :CDMARCA,
              DTTESTE = :DTTESTE,
              NMRESPTESTE = :NMRESPTESTE,
              DTVALAPRTEST = :DTVALAPRTEST,
              IDMARCAPRTES = :IDMARCAPRTES,
              IDTIPREN = :IDTIPREN,
              VRRENDATUTES = :VRRENDATUTES,
              DSRENDATUAL = :DSRENDATUAL,
              NMFABROPCTES = :NMFABROPCTES,
              NMTIPOEMBAL = :NMTIPOEMBAL,
              IDEMBDATVAL = :IDEMBDATVAL,
              DSREGISTTEST = :DSREGISTTEST,
              IDASPVISUAL = :IDASPVISUAL,
              IDASPCOR = :IDASPCOR,
              IDASPODOR = :IDASPODOR,
              IDASPSABOR = :IDASPSABOR,
              IDASPTEXT = :IDASPTEXT,
              IDTESTBROM = :IDTESTBROM,
              IDPRATEMB = :IDPRATEMB,
              IDPRATMANIP = :IDPRATMANIP,
              HRTEMPOELAB = :HRTEMPOELAB,
              IDLEGIVIGE = :IDLEGIVIGE
            where
              NRTESTEPROD = :NRTESTEPROD";
        try {
            $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $this->updateTesteprod($row);
            $this->procedureUpdate($row);
            $this->insertMarcprod($row);
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function apagaTeste($row) {
        $param = array(
		    'P_CDMARCA'  => $row['CDMARCA'],
		    'P_NRTESTEPROD'  => $row['NRTESTEPROD']
		);
        $query = "UPDATE QFOMARPROD
            SET NRTESTEPROD = NULL,
              DTTESTEQUA    = NULL,
              VRRENDATU     = NULL
            WHERE CDMARCA = :P_CDMARCA
            AND NRTESTEPROD = :P_NRTESTEPROD";
        try {
            $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->execute($param);
            if($row['excQuali'] == true){
                $param2 = array(
        		    'P_CDPRODUTO'  => $row['CDPRODUTO'],
        		    'P_CDMARCA'  => $row['CDMARCA']
        		);
                $query2 = "DELETE FROM QFOMARPROD WHERE CDPRODUTO = :P_CDPRODUTO AND CDMARCA = :P_CDMARCA";
                $std2 = $this->connection->prepare($query2);
                $std2->execute($param2);
            }
            
            if($row['excMarca'] == true){
                $param3 = array(
                    'P_CDMARCA'  => $row['CDMARCA'],
        		    'P_CDPRODUTO'  => $row['CDPRODUTO']
        		);
                $query3 = "DELETE FROM MARCPROD
                    WHERE
                      CDMARCA = :P_CDMARCA AND
                      EXISTS
                       (SELECT
                          CDPRODUTO
                        FROM
                          PRODUTO
                        WHERE
                          PRODUTO.CDPRODESTO = :P_CDPRODUTO AND
                          PRODUTO.CDPRODUTO  = MARCPROD.CDPRODUTO)";
                $std3 = $this->connection->prepare($query3);
                $std3->execute($param3);
            }
            
            $param4 = array(
    		    'P_NRTESPRDORIG'  => $row['NRTESPRDORIG']
    		);
            $query4 = "SELECT
              CDPRODUTO,
              CDMARCA,
              NRTESTEPROD
            FROM
              TESTEPROD
            WHERE
              NRTESPRDORIG = :P_NRTESPRDORIG";
            $std4 = $this->connection->prepare($query4);
            $std4->execute($param4);
            $produtos = $std4->fetchAll();
            if(!empty($produtos)){
                foreach ($produtos as $key => $produto) {
                    if($row['excQuali'] == true){
                        $param5 = array(
                		    'P_CDPRODUTO'  => $produto['CDPRODUTO'],
                		    'P_CDMARCA'  => $produto['CDMARCA']
                		);
                        $query5 = "DELETE FROM QFOMARPROD WHERE CDPRODUTO = :P_CDPRODUTO AND CDMARCA = :P_CDMARCA";
                        $std5 = $this->connection->prepare($query5);
                        $std5->execute($param5);
                    }
            
                    if($row['excMarca'] == true){
                        $param6 = array(
                            'P_CDMARCA'  => $produto['CDMARCA'],
                		    'P_CDPRODUTO'  => $produto['CDPRODUTO']
                		);
                        $query6 = "DELETE FROM MARCPROD
                            WHERE
                              CDMARCA = :P_CDMARCA AND
                              EXISTS
                               (SELECT
                                  CDPRODUTO
                                FROM
                                  PRODUTO
                                WHERE
                                  PRODUTO.CDPRODESTO = :P_CDPRODUTO AND
                                  PRODUTO.CDPRODUTO  = MARCPROD.CDPRODUTO)";
                        $std6 = $this->connection->prepare($query6);
                        $std6->execute($param6);
                    }
            
                }
            }
            $param7 = array(
    		    'P_NRTESPRDORIG'  => $row['NRTESPRDORIG']
    		);
            $query7 = "DELETE FROM TESTEPROD WHERE NRTESPRDORIG = :P_NRTESPRDORIG";
            $std7 = $this->connection->prepare($query7);
            $std7->execute($param7);
                        
            $param8 = array(
    		    'P_NRTESTEPROD'  => $row['NRTESTEPROD']
    		);
            $query8 = "DELETE FROM TESTEPROD WHERE NRTESTEPROD = :P_NRTESTEPROD";
            $std8 = $this->connection->prepare($query8);
            $std8->execute($param8);
            
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function procedureIncluir($row) {
        {
            $connection = $this->connection;
            $procedure = new StoredProcedure($connection, 'INSERE_PRODFORNCMP_MARCFORNCMP');
            $procedure->addParam(new Param('P_CDFORNECED',  Param::PARAM_INPUT,  "",                    Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDMARCA',     Param::PARAM_INPUT,  $row['CDMARCA'],       Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDPRODUTO',   Param::PARAM_INPUT, $row['CDPRODUTO'],    Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDARVPROD',   Param::PARAM_INPUT, $row['CDARVPROD'],    Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_ARRED',    Param::PARAM_INPUT,    "",                    Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFORNORIG',  Param::PARAM_INPUT, "",                    Param::PARAM_TYPE_STR));
            $rowsaffect = $procedure->execute();
        }
    }
    
    public function updateTesteprod($row) {
        $param = array(
		    'NRTESTEPROD'  => $row['NRTESTEPROD']
		);
        $query = "UPDATE TESTEPROD
        SET (DTTESTE,
             CDFORNECED,
             NMRESPTESTE,
             IDMARCAPRTES,
             DTVALAPRTEST,
             VRRENDATUTES,
             DSRENDATUAL,
             IDTIPREN,
             NMFABROPCTES,
             NMTIPOEMBAL,
             IDEMBDATVAL,
             DSREGISTTEST,
             IDASPVISUAL,
             IDASPCOR,
             IDASPODOR,
             IDASPSABOR,
             IDASPTEXT,
             IDTESTBROM,
             IDPRATEMB,
             IDPRATMANIP,
             HRTEMPOELAB,
             IDLEGIVIGE) =
             (SELECT
                DTTESTE,
                CDFORNECED,
                NMRESPTESTE,
                IDMARCAPRTES,
                DTVALAPRTEST,
                VRRENDATUTES,
                DSRENDATUAL,
                IDTIPREN,
                NMFABROPCTES,
                NMTIPOEMBAL,
                IDEMBDATVAL,
                DSREGISTTEST,
                IDASPVISUAL,
                IDASPCOR,
                IDASPODOR,
                IDASPSABOR,
                IDASPTEXT,
                IDTESTBROM,
                IDPRATEMB,
                IDPRATMANIP,
                HRTEMPOELAB,
                IDLEGIVIGE
             FROM
                TESTEPROD A
             WHERE
                A.NRTESTEPROD = :NRTESTEPROD)
        WHERE
           TESTEPROD.NRTESPRDORIG = :NRTESTEPROD";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function procedureUpdate($row) {
        {
            $connection = $this->connection;
            $procedure = new StoredProcedure($connection, 'UPDATE_QFOMARPROD');
            $procedure->addParam(new Param('P_NRTESTEPROD',   Param::PARAM_INPUT, $row['NRTESTEPROD'],    Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_UTILIZAREND',   Param::PARAM_INPUT,                  'N',    Param::PARAM_TYPE_STR));
            $rowsaffect = $procedure->execute();
        }
    }
    
    public function insertMarcprod($row) {
        $param = array(
		    'CDMARCA'    => $row['CDMARCA'],
		    'CDPRODUTO'  => $row['CDPRODUTO']
		);
        $query = "INSERT INTO MARCPROD
        (CDPRODUTO, CDMARCA)
        (SELECT
           PRODUTO.CDPRODUTO,
           :CDMARCA
         FROM
          PRODUTO,
          PRODUTO PRS
         WHERE
          PRS.CDPRODUTO             = :CDPRODUTO AND
          PRODUTO.CDPRODESTO = PRS.CDPRODESTO AND
          NOT EXISTS
          (SELECT
            MARCPROD.CDMARCA
           FROM
            MARCPROD,
            PRODUTO P
           WHERE
            MARCPROD.CDPRODUTO = P.CDPRODUTO AND
            MARCPROD.CDMARCA   = :CDMARCA AND
            PRODUTO.CDARVPROD LIKE P.CDARVPROD || '%'))";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function salvaObservacao($row) {
        $param = array(
		    'NRTESTEPROD'  => $row['NRTESTEPROD']
		);
        $query = "INSERT INTO OBSTESTPROD (NRTESTEPROD, DSOBSTEST) VALUES (:NRTESTEPROD, :DSOBSTEST)";
        try {
            $observacao = $row['DSOBSTEST'];
            $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->bindValue(':DSOBSTEST', $observacao, ParameterType::LARGE_OBJECT);
            $std->execute($param);
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function atualizaObservacao($row) {
        $param = array(
		    'NRTESTEPROD'  => $row['NRTESTEPROD']
		);
        $query = "UPDATE OBSTESTPROD SET DSOBSTEST = :DSOBSTEST WHERE NRTESTEPROD = :NRTESTEPROD";
        try {
            $observacao = $row['DSOBSTEST'];
            $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->bindValue(':DSOBSTEST', $observacao, ParameterType::LARGE_OBJECT);
            $std->execute($param);
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function apagaObservacao($row) {
        $param = array(
		    'NRTESTEPROD'  => $row['NRTESTEPROD']
		);
        $query = "DELETE FROM OBSTESTPROD WHERE NRTESTEPROD = :NRTESTEPROD";
        try {
            $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function addTipoPrato($row) {
        $param = array(
		    'NRTESTEPROD'  => $row['NRTESTEPROD'],
		    'CDTIPOPRAT'   => $row['CDTIPOPRAT']
		);
        $query = "INSERT INTO TPPRATTEST (NRTESTEPROD, CDTIPOPRAT) VALUES (:NRTESTEPROD, :CDTIPOPRAT)";
        try {
            $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $this->procedureCriteriosdeAnalise($row);
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function deleteTipoPrato($rows) {
        try {
            foreach ($rows as $key => $row) {
                $param = array(
        		    'NRTESTEPROD'  => $row['NRTESTEPROD'],
        		    'CDTIPOPRAT'   => $row['CDTIPOPRAT']
        		);
                $query = "DELETE FROM TPPRATTEST WHERE NRTESTEPROD = :NRTESTEPROD AND CDTIPOPRAT = :CDTIPOPRAT";
                $this->connection->beginTransaction();
                $std = $this->connection->prepare($query);
                $std->execute($param);
                $this->procedureCriteriosdeAnalise($row);
                $this->connection->commit();
            }
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function addMarcaReferencia($row) {
        $param = array(
		    'NRTESTEPROD'  => $row['NRTESTEPROD'],
		    'CDMARCA'      => $row['CDMARCA']
		);
        $query = "INSERT INTO  MARCTESTPR (NRTESTEPROD, CDMARCA) VALUES (:NRTESTEPROD, :CDMARCA)";
        try {
            $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $this->procedureCriteriosdeAnalise($row);
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deleteMarcaRefefencia($rows) {
        try {
            foreach ($rows as $key => $row) {
                $param = array(
        		    'NRTESTEPROD'  => $row['NRTESTEPROD'],
        		    'CDMARCA'      => $row['CDMARCA']
        		);
                $query = "DELETE FROM MARCTESTPR WHERE NRTESTEPROD = :NRTESTEPROD AND CDMARCA = :CDMARCA";
                $this->connection->beginTransaction();
                $std = $this->connection->prepare($query);
                $std->execute($param);
                $this->procedureCriteriosdeAnalise($row);
                $this->connection->commit();
            }
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }    
    
    public function apagaCustoBeneficio($row) {
        $param = array(
		    'NRTESTEPROD'  => $row['NRTESTEPROD']
		);
        $query = "DELETE FROM CUSBENTEST WHERE NRTESTEPROD = :NRTESTEPROD";
        try {
            $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $this->procedureCriteriosdeAnalise($row);
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function atualizaCustoBeneficio($row) {
        $param = array(
		    'NRTESTEPROD'  => $row['NRTESTEPROD']
		);
        $query = "UPDATE CUSBENTEST SET DSCUSBENTEST = :DSCUSBENTEST WHERE NRTESTEPROD = :NRTESTEPROD";
        try {
            $custoBeneficio = $row['DSCUSBENTEST'];
            $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->bindValue(':DSCUSBENTEST', $custoBeneficio, ParameterType::LARGE_OBJECT);
            $std->execute($param);
            $this->procedureCriteriosdeAnalise($row);
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function salvaCustoBeneficio($row) {
        $param = array(
		    'NRTESTEPROD'  => $row['NRTESTEPROD']
		);
        $query = "INSERT INTO CUSBENTEST (NRTESTEPROD, DSCUSBENTEST) VALUES (:NRTESTEPROD, :DSCUSBENTEST)";
        try {
            $custoBeneficio = $row['DSCUSBENTEST'];
            $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->bindValue(':DSCUSBENTEST', $custoBeneficio, ParameterType::LARGE_OBJECT);
            $std->execute($param);
            $this->procedureCriteriosdeAnalise($row);
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function procedureCriteriosdeAnalise($row) {
        {
            $connection = $this->connection;
            $procedure = new StoredProcedure($connection, 'TESTEPROD_UPCHILD');
            $procedure->addParam(new Param('P_NRTESTEPROD',   Param::PARAM_INPUT, $row['NRTESTEPROD'],    Param::PARAM_TYPE_STR));
            $rowsaffect = $procedure->execute();
        }
    }
    
    public function procedureUpdateRendimento($row) {
        {
            $connection = $this->connection;
            $procedure = new StoredProcedure($connection, 'UPDATE_QFOMARPROD');
            $procedure->addParam(new Param('P_NRTESTEPROD',   Param::PARAM_INPUT, $row['NRTESTEPROD'],    Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_UTILIZAREND',   Param::PARAM_INPUT, $row['P_UTILIZAREND'],    Param::PARAM_TYPE_STR));
            $rowsaffect = $procedure->execute();
        }
    }
    
    public function salvaCadastramentoAutomatico($row) {
        $param = array(
		    'P_NRTESTEPROD'  => $row['NRTESTEPROD']
		);
        $query = "SELECT
           TESTEPROD.NRTESTEPROD,
           TESTEPROD.DTTESTE,
           TESTEPROD.CDMARCA,
           TESTEPROD.CDFORNECED,
           TESTEPROD.NMRESPTESTE,
           TESTEPROD.IDMARCAPRTES,
           TESTEPROD.DTVALAPRTEST,
           TESTEPROD.VRRENDATUTES,
           TESTEPROD.DSRENDATUAL,
           TESTEPROD.IDTIPREN,
           TESTEPROD.NMFABROPCTES,
           TESTEPROD.NMTIPOEMBAL,
           TESTEPROD.IDEMBDATVAL,
           TESTEPROD.DSREGISTTEST,
           TESTEPROD.IDASPVISUAL,
           TESTEPROD.IDASPCOR,
           TESTEPROD.IDASPODOR,
           TESTEPROD.IDASPSABOR,
           TESTEPROD.IDASPTEXT,
           TESTEPROD.IDTESTBROM,
           TESTEPROD.IDPRATEMB,
           TESTEPROD.IDPRATMANIP,
           TESTEPROD.HRTEMPOELAB,
           OBSTESTPROD.DSOBSTEST,
           TESTEPROD.NRTESPRDORIG
    FROM TESTEPROD, OBSTESTPROD
    WHERE
       (TESTEPROD.NRTESTEPROD = :P_NRTESTEPROD) AND
       (TESTEPROD.NRTESTEPROD = OBSTESTPROD.NRTESTEPROD(+))";
        try {
            $this->connection->beginTransaction();
            $std = $this->connection->prepare($query);
            $std->execute($param);
            $resultado = $std->fetch();
            $marca = $resultado["CDMARCA"];
            $param2 = array(
    		    'P_CDPRODINI'  => $row['P_PRODUTOINI'],
    		    'P_CDPRODFIM'  => $row['P_PRODUTOFIN'],
    		    'P_CDMARCA'  => $marca
    		);
            $query2 = "SELECT CDPRODUTO
                FROM PRODUTO
                WHERE (PRODUTO.CDARVPROD BETWEEN :P_CDPRODINI AND :P_CDPRODFIM) AND
                      (PRODUTO.CDPRODESTO IS NOT NULL) AND
                      NOT EXISTS(SELECT
                                    NRTESTEPROD
                                 FROM
                                    TESTEPROD
                                 WHERE
                                    TESTEPROD.CDMARCA   = :P_CDMARCA AND
                                    TESTEPROD.CDPRODUTO = PRODUTO.CDPRODUTO)";
            $std2 = $this->connection->prepare($query2);
            $std2->execute($param2);
            $produtos = $std2->fetchAll();
            foreach ($produtos as $key => $produto) {
                $novoCodigo = $this->novoCodigo->getCodeByTableName('TESTEPROD', $this->environment->getNrorgTrab(), 1, 10, false);
                $param3 = array(
        		    'NRTESTEPROD'  => $novoCodigo,
        		    'DTTESTE'   => $resultado['DTTESTE'],
        		    'CDPRODUTO'   => $produto['CDPRODUTO'],
        		    'CDMARCA'   => $resultado['CDMARCA'],
        		    'CDFORNECED'   => $resultado['CDFORNECED'],
        		    'NMRESPTESTE'   => $resultado['NMRESPTESTE'],
        		    'IDMARCAPRTES'   => $resultado['IDMARCAPRTES'],
        		    'DTVALAPRTEST'   => $resultado['DTVALAPRTEST'],
        		    'VRRENDATUTES'   => floatval($resultado['VRRENDATUTES']),
        		    'DSRENDATUAL'   => $resultado['DSRENDATUAL'],
        		    'IDTIPREN'   => $resultado['IDTIPREN'],
        		    'NMFABROPCTES'   => $resultado['NMFABROPCTES'],
        		    'NMTIPOEMBAL'   => $resultado['NMTIPOEMBAL'],
        		    'IDEMBDATVAL'   => $resultado['IDEMBDATVAL'],
        		    'DSREGISTTEST'   => $resultado['DSREGISTTEST'],
        		    'IDASPVISUAL'   => $resultado['IDASPVISUAL'],
        		    'IDASPCOR'   => $resultado['IDASPCOR'],
        		    'IDASPODOR'   => $resultado['IDASPODOR'],
        		    'IDASPSABOR'   => $resultado['IDASPSABOR'],
        		    'IDASPTEXT'   => $resultado['IDASPTEXT'],
        		    'IDTESTBROM'   => $resultado['IDTESTBROM'],
        		    'IDPRATEMB'   => $resultado['IDPRATEMB'],
        		    'IDPRATMANIP'   => $resultado['IDPRATMANIP'],
        		    'HRTEMPOELAB'   => $resultado['HRTEMPOELAB'],
        		    'NRTESPRDORIG'   => $resultado['NRTESPRDORIG']
        		);
                $query3 = "INSERT INTO TESTEPROD
                  (NRTESTEPROD, DTTESTE, CDPRODUTO, CDMARCA, CDFORNECED, NMRESPTESTE, IDMARCAPRTES, 
                   DTVALAPRTEST, VRRENDATUTES, DSRENDATUAL, IDTIPREN, NMFABROPCTES, NMTIPOEMBAL, 
                   IDEMBDATVAL, DSREGISTTEST, IDASPVISUAL, IDASPCOR, IDASPODOR, IDASPSABOR, 
                   IDASPTEXT, IDTESTBROM, IDPRATEMB, IDPRATMANIP, HRTEMPOELAB, NRTESPRDORIG)
                VALUES
                  (:NRTESTEPROD, :DTTESTE, :CDPRODUTO, :CDMARCA, :CDFORNECED, :NMRESPTESTE, 
                   :IDMARCAPRTES, :DTVALAPRTEST, :VRRENDATUTES, :DSRENDATUAL, :IDTIPREN, 
                   :NMFABROPCTES, :NMTIPOEMBAL, :IDEMBDATVAL, :DSREGISTTEST, :IDASPVISUAL, 
                   :IDASPCOR, :IDASPODOR, :IDASPSABOR, :IDASPTEXT, :IDTESTBROM, :IDPRATEMB, 
                   :IDPRATMANIP, :HRTEMPOELAB, :NRTESPRDORIG)";
                $std3 = $this->connection->prepare($query3);
                $std3->execute($param3);
                $this->procedureUpdateCadastramento($row, $novoCodigo);
                $this->insertMarcprodCadastramento($marca, $produto['CDPRODUTO']);
                if($resultado['DSOBSTEST'] !== null){
                    $this->salvaObservacaoCadastramento($novoCodigo, $resultado['DSOBSTEST']);
                }
                $this->procedureUpchildCadastramento($novoCodigo);
            }
            $this->connection->commit();
        } catch (Exception $e){
            $this->connection->rollback();
            throw $e;
        }
        
    }
    
    public function procedureUpdateCadastramento($row, $novoCodigo) {
        {
            $connection = $this->connection;
            $procedure = new StoredProcedure($connection, 'UPDATE_QFOMARPROD');
            $procedure->addParam(new Param('P_NRTESTEPROD',   Param::PARAM_INPUT, $novoCodigo,       Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_UTILIZAREND',   Param::PARAM_INPUT, $row['DISPRENDIMENTO'],    Param::PARAM_TYPE_STR));
            $rowsaffect = $procedure->execute();
        }
    }
    
    public function insertMarcprodCadastramento($marca, $produto) {
        $param = array(
		    'P_CDMARCA'    => $marca,
		    'P_CDPRODUTO'  => $produto
		);
        $query = "INSERT INTO MARCPROD
           (CDPRODUTO, CDMARCA)
        (SELECT
           PRODUTO.CDPRODUTO,
           :P_CDMARCA
         FROM
          PRODUTO,
          PRODUTO PRS
         WHERE
          PRS.CDPRODUTO = :P_CDPRODUTO AND 
          PRODUTO.CDPRODESTO = PRS.CDPRODESTO AND
          NOT EXISTS
          (SELECT
            CDMARCA
           FROM
            MARCPROD, PRODUTO P
           WHERE
            P.CDPRODUTO = MARCPROD.CDPRODUTO AND
            CDMARCA   = :P_CDMARCA AND
            PRODUTO.CDARVPROD LIKE P.CDARVPROD || '%'))";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function salvaObservacaoCadastramento($nrtesteprod, $dsobsteste) {
        $param = array(
		    'NRTESTEPROD'  => $nrtesteprod
		);
        $query = "INSERT INTO OBSTESTPROD (NRTESTEPROD, DSOBSTEST) VALUES (:NRTESTEPROD, :DSOBSTEST)";
        try {
            $observacaoCadastramento = $dsobsteste;
            $std = $this->connection->prepare($query);
            $std->bindValue(':DSOBSTEST', $observacaoCadastramento, ParameterType::LARGE_OBJECT);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function procedureUpchildCadastramento($novoCodigo) {
        {
            $connection = $this->connection;
            $procedure = new StoredProcedure($connection, 'TESTEPROD_UPCHILD');
            $procedure->addParam(new Param('P_NRTESTEPROD',   Param::PARAM_INPUT, $novoCodigo,    Param::PARAM_TYPE_STR));
            $rowsaffect = $procedure->execute();
        }
    }
    
}